<template>
    <el-drawer :title="title" :visible.sync="drawer" size="60%">
        <div class="bbsl-common-page">
            <div class="bbsl-table-search">
                <el-button-group style="width: 30%">
                    <el-tooltip content="选取点位" effect="light">
                        <el-button
                            type="primary"
                            icon="el-icon-location-information"
                            @click="selectPoint"
                        />
                    </el-tooltip>
                    <el-tooltip content="选取区域" effect="light">
                        <el-button
                            type="primary"
                            icon="el-icon-edit-outline"
                            @click="selectArea"
                        />
                    </el-tooltip>
                    <el-tooltip content="清除" effect="light">
                        <el-button
                            type="primary"
                            icon="el-icon-delete"
                            @click="clear"
                        />
                    </el-tooltip>
                </el-button-group>

                <div style="text-align: right; width: 70%">
                    <el-button
                        type="primary"
                        icon="el-icon-search"
                        @click="confirm"
                        >确定</el-button
                    >
                    <el-button
                        type="primary"
                        icon="el-icon-search"
                        @click="drawer = false"
                        >取消</el-button
                    >
                </div>
            </div>
            <div ref="contentPanel" class="bbsl-table-content">
                <!-- <Iframe :src="src" /> -->
                <iframe
                    ref="windowiframe"
                    :src="src"
                    frameborder="0"
                    style="width: 100%; height: 100%; text-align: center"
                    scrolling="auto"
                    align="absmiddle"
                />
            </div>
        </div>
    </el-drawer>
</template>

<script>
export default {
    name: 'GisMapDrawer',
    components: {},
    props: {
        afterConfirm: {
            type: Function,
            default: null,
        },
    },

    data() {
        return {
            drawer: false,
            selectVal: [],
            params: null,
            title: '',
            // src: '/gisapi/station-n-map/#/DeviceManagerGisView?mapMode=2D'
            src: 'http://183.230.176.125:18081/station-n-map/#/DeviceManagerGisView?mapMode=2D',
        }
    },
    methods: {
        setArea(row) {
            this.params = row

            this.title = '设置【' + row.name + '】的区域'
            this.selectVal = []
            this.drawer = true

            if (this.params.area) {
                if (this.$refs.windowiframe) {
                    this.clear()
                    this.$refs.windowiframe.contentWindow.deviceGisFunction.addElectronicFence(
                        {
                            id: this.params.id,
                            points: JSON.parse(this.params.area),
                        },
                        []
                    )
                } else {
                    const t = this
                    setTimeout(function () {
                        t.clear()
                        t.$refs.windowiframe.contentWindow.deviceGisFunction.addElectronicFence(
                            {
                                id: t.params.id,
                                points: JSON.parse(t.params.area),
                            },
                            []
                        )
                    }, 6000)
                }
            } else {
                if (this.$refs.windowiframe) {
                    this.clear()
                }
            }
        },
        selectPoint() {
            this.$refs.windowiframe.contentWindow.deviceGisFunction
                .pickPoint()
                .then((point) => {
                    // alert(point)
                    this.selectVal.push(point)
                    console.log(point)
                })
        },

        selectArea() {
            this.$refs.windowiframe.contentWindow.deviceGisFunction
                .drawPolygon()
                .then((area) => {
                    this.selectVal = []
                    this.selectVal.push(area)
                    console.log(area)
                })
        },

        clear() {
            this.$refs.windowiframe.contentWindow.deviceGisFunction.clearPolygonDraw()
            this.$refs.windowiframe.contentWindow.deviceGisFunction.clearElectronicFence()
        },

        confirm() {
            if (
                !this.selectVal ||
                this.selectVal === null ||
                this.selectVal.length === 0
            ) {
                this.$message.warning('没有任何可选信息')
                return
            }
            this.$emit('confirm', this.selectVal, this.params)
            this.drawer = false
        },
    },
}
</script>
